/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: sample1.c 1801 2015-03-27 06:34:43Z t_ishikawa $
 */

/*
 *		ץץ(1)
 *
 *  ATK2-SC1δŪưǧ뤿Υץץ
 *
 *  ץγסPCȥܡɴ֤ǥꥢ̿Ԥ桼
 *  ޥɤ˱ưȥϤԤʤ
 *
 *  㥳ޥɰ
 *  
 *    '1' : ʹߤΥޥɤ Task1 ФƹԤ
 *    '2' : ʹߤΥޥɤ Task2 ФƹԤ
 *    '3' : ʹߤΥޥɤ Task3 ФƹԤ
 *    '4' : ʹߤΥޥɤ Task4 ФƹԤ
 *    '5' : ʹߤΥޥɤ Task5 ФƹԤ
 *  ǽ
 *    'a' : ActivateTask ˤƥư롥
 *    'A' : TerminateTask ˤƥλ롥
 *    '!'(Shift+1) : ChainTask ˤƥλTask1 ư
 *    '"'(Shift+2) : ChainTask ˤƥλTask2 ư
 *    '#'(Shift+3) : ChainTask ˤƥλTask3 ư
 *    '$'(Shift+4) : ChainTask ˤƥλTask4 ư
 *    '%'(Shift+5) : ChainTask ˤƥλTask5 ư
 *    's' : Υץꥨץƥ°Ǥ륿 MainTask ˤƺǹ
 *          ͥ٥ HighPriorityTask ưSchedule ˤ
 *          ƥ塼󥰤Ԥ
 *    'S' : Υץꥨץƥ֥ NonPriTask ư
 *          Υץꥨץƥ֥ NonPriTask ˤƺǹͥ
 *           HighPriorityTask ưλ
 *    'z' : ¹Υ GetTaskID ¹Ԥơ¹Ծ֤ TaskID 
 *    'Z' : ᥤ󥿥 GetTaskState ¹Ԥơоݥξ֤
 *    'x' : div̿¹Ԥơ̤̿㳰ȯ
 *  ߴǽ
 *    'd' : DisableAllInterrupts ¹Ը塤ϡɥͤ
 *          3ɽ EnableAllInterrupts ¹Ԥ
 *    'D' : SuspendAllInterrupts ¹Ը塤ϡɥͤ
 *          3ɽ SuspendAllInterrupts ¹Ը塤ϡ
 *          ͤ3ɽResumeAllInterrupts ¹Ը塤
 *          ϡɥͤ3ɽResumeAllInterrupts 
 *          ¹Ԥ
 *    'f' : SuspendOSInterrupts ¹Ը塤ϡɥͤ
 *          3ɽ SuspendOSInterrupts ¹Ը塤ϡ
 *          ͤ3ɽ SuspendAllInterrupts
 *          ¹Ը塤ϡɥͤ3ɽ
 *          ResumeAllInterrupts ¹Ը塤ϡɥ󥿤3
 *          ɽResumeOSInterrupts ¹Ըϡɥ
 *          ͤ3ɽResumeOSInterrupts ¹Ԥ
 *    'T' : ϡɥͤ3ɽ
 *  ꥽ǽ
 *    'k' : GetResource ˤƥ꥽ TskLevelRes 롥ʤ
 *          Task3 ϡΥ꥽ͥ٤⤤ᥨ顼Ȥʤ
 *    'K' : ReleaseResource ˤƥ꥽ TskLevelRes 
 *    'i' : GetResource ˤƥ꥽ CntRes 塤ϡɥ
 *          ͤ3ɽReleaseResource ˤƥ꥽
 *          CntRes 
 *  ٥浡ǽ
 *    'e' : SetEvent ˤƥ٥Ȥꤹ롥Task2  Task3 ʳ
 *          Ƥʤᥨ顼Ȥʤ
 *    'w' : ClearEvent ˤƼΥ٥Ȥ򥯥ꥢ롥Task2 
 *          Task3 ʳϳƤʤᥨ顼Ȥʤ
 *    'E' : GetEvent ˤƥ٥Ⱦ֤롥Task2  Task3
 *          ʳϳƤʤᥨ顼Ȥʤ
 *    'W' : WaitEvent ˤƼΥ٥ȤԤġTask3  Task4
 *          ʳϥ顼Ȥʤ
 *  顼ൡǽ
 *    'b' : GetAlarmBase ˤƥ顼 MainCycArm Υ顼١
 *          
 *    'B' : GetAlarm ˤƥ顼 MainCycArm λĤꥫͤ2
 *          Ϣ³Ǽ
 *    'v' : SetRelAlarm ˤƥ顼 ActTskArm ư500ms 
 *           Task1 ư
 *    'V' : SetRelAlarm ˤƥ顼 SetEvtArm ư500ms 
 *          ٥ T3Evt ꤹ
 *    'n' : SetRelAlarm ˤƥ顼 CallBackArm 򡤥ѥ᡼
 *          900ms λñȯ顼ꤹ
 *    'N' : SetRelAlarm ˤƥ顼 CallBackArm 򡤥ѥ᡼
 *          900ms λ 500ms 顼ꤹ
 *    'm' : SetAbsAlarm ˤƥ顼 CallBackArm 򡤥ѥ᡼
 *          900λñȯ顼ꤹ
 *    'M' : SetAbsAlarm ˤƥ顼 CallBackArm 򡤥ѥ᡼
 *          900λ 500ms 顼ꤹ
 *    'h' : CancelAlarm ˤƥ顼 CallBackArm 򥭥󥻥뤹
 *  ǽ
 *    'c' : ˤ IncrementCounter ¹Ԥ SampleCnt
 *          ˥ʥΤ
 *          1 ʥǥ顼 SampleArm λХå
 *          ¹Ԥ
 *    'C' : ˤ IncrementCounter ¹Ԥ SampleCnt2
 *          ˥ʥΤ
 *          1 ʥǥ顼 SampleArm1 λSampleCnt3 
 *          󥯥Ȥ롥 SampleCnt3  1 ʥ SampleAlm2
 *          λХå¹Ԥ
 *    'j' : ˤ GetCounterValue ¹Ԥ
 *          ͤ¸
 *    'J' : ˤ GetEalsedCounterValue ¹Ԥ
 *          ͤGetCounterValue ޤ GetEalsedCounterValue ˤƼ
 *          ͤȤ롥󡤤ޤϡGetCounterValue¹ԤƤʤ0
 *          Ȥ
 *
 *    'r' : ˤ GetISRID¹Ԥ
 *          ƥȤGetISRIDƽФϥ顼Ȥ
 *          INVALID_ISRֵѤ
 *
 *          ߥƥȤGetISRIDȯԤϡSystemTimerCntΥХå
 *          롼'n' ޥɤǼ¹ԡˤˤƹԤ
 *
 *          ƥȤGetISRIDȯԤϡSampleCnt2ΥХå
 *          롼'C' ޤ 'c' ޥɤǼ¹ԡˤˤƹԤ
 *
 *  塼ơ֥浡ǽ
 *    't' : 塼ơ֥ưON/OFF
 *
 *        'i' : SchtblSampleCnt󥿤򥤥󥯥Ȥ
 *              SchtblSampleCnt󥿤ϥ塼ơ֥ζư
 *        '1' : ʹߤΥޥɤ scheduletable1 ФƹԤ(ǥե)
 *        '2' : ʹߤΥޥɤ scheduletable2 ФƹԤ
 *        '3' : ʹߤΥޥɤ scheduletable3(¸ߤʤID) ФƹԤ
 *              ޥɤΥ顼ǧˤѤ
 *        's' : StartScheduleTableRel¹Ԥ(5)ǥ塼ơ֥򳫻Ϥ
 *        'S' : StartScheduleTableAbs¹Ԥ(5)ǥ塼ơ֥򳫻Ϥ
 *        'f' : StopScheduleTable¹Ԥ塼ơ֥ߤ
 *        'n' : NextScheduleTable¹Ԥscheduletable2ؤ
 *        'N' : NextScheduleTable¹Ԥscheduletable1ؤ
 *        'g' : GetScheduleTableStatus¹Ԥ塼ơ֥֤
 *        'q' : ShutdownOS( E_OK ) OS¹浡ǽ'q'Ʊǽ
 *        'Q' : ShutdownOS( E_OS_STATE ) OS¹浡ǽ'Q'Ʊǽ
 *
 *  OS¹浡ǽ
 *    'p' : GetActiveApplicationMode ˤƥץꥱ⡼ɤ
 *          
 *    'q' : ShutdownOS 򥳡 E_OK Ǽ¹Ԥץץ
 *          λ
 *    'Q' : ShutdownOS 򥳡 E_OS_STATE Ǽ¹Ԥץץ
 *          λ
 *
 *  㥪֥Ȱ
 *  OS
 *    ȥåץեå
 *    åȥեå
 *    顼եå
 *    ץ쥿եå̤
 *    ݥȥեå̤
 *  
 *  ᥤ󥿥
 *    IDMainTask
 *    ͥ١14
 *    ¿ŵư1
 *    塼롧Υץꥨץƥ
 *    ưưAppMode1, AppMode2, AppMode3
 *    ס桼󥿥եʥꥢIOꥳޥɤ
 *          бưԤʤ
 *          顼 MainCycArm ˤꡤ10msȤԤ
 *          ޥɤμ̵ͭݡ󥰤
 *          ٥ȡIDMainEvtˤϢդƤ
 *  ǹͥ٥
 *    IDHighPriorityTask
 *    ͥ١15
 *    ¿ŵư1
 *    塼롧եץꥨץƥ
 *    ưưʤ
 *    סưϤƽλ롥Υץꥨץƥ֥
 *          鵯ư졤ץꥨץȤƤ뤫ɤγǧ
 *  Υץꥨץƥ֥
 *    IDNonPriTask
 *    ͥ١1
 *    ¿ŵư8
 *    塼롧Υץꥨץƥ
 *    ưưʤ
 *    סưϤǹͥ٥ HighPriorityTask 
 *          ư塤λϤƥλ
 *  1
 *    IDTask1
 *    ͥ١4
 *    塼롧եץꥨץƥ
 *    ưưAppMode2
 *    ¿ŵư8
 *    סʥᥤ󥿥λˤư
 *          ư줹̵¥롼פꡤޥɽ¹Ԥ
 *          ꥽ TskLevelRes ϢդƤ
 *          ꥽ CntRes ϢդƤ
 *  2
 *    IDTask2
 *    ͥ١7
 *    ¿ŵư1
 *    塼롧եץꥨץƥ
 *    ưưʤ
 *    סʥᥤ󥿥λˤư
 *          ư줹̵¥롼פꡤޥɽ¹Ԥ
 *          ꥽ TskLevelRes ϢդƤ
 *          ꥽ CntRes ϢդƤ
 *          ٥ T2Evt ϢդƤ
 *  3
 *    IDTask3
 *    ͥ١12
 *    ¿ŵư1
 *    塼롧եץꥨץƥ
 *    ưưAppMode3
 *    סʥᥤ󥿥λˤư
 *          ư줹̵¥롼פꡤޥɽ¹Ԥ
 *          ٥Ԥ뤳ȤǽǤ
 *          ꥽ CntRes ϢդƤ
 *          ٥ T3Evt ϢդƤ
 *  4
 *    IDTask4
 *    ͥ١6
 *    ¿ŵư5
 *    塼롧եץꥨץƥ
 *    ưưʤ
 *    סʥᥤ󥿥λˤư
 *          ư줹̵¥롼פꡤޥɽ¹Ԥ
 *          ꥽ TskLevelRes ϢդƤ
 *          ꥽ CntRes ϢդƤ
 *          ꥽ GroupRes ϢդƤ
 *  5
 *    IDTask5
 *    ͥ١9
 *    ¿ŵư5
 *    塼롧եץꥨץƥ
 *    ưưʤ
 *    סʥᥤ󥿥λˤư
 *          ư줹̵¥롼פꡤޥɽ¹Ԥ
 *          ꥽ TskLevelRes ϢդƤ
 *          ꥽ CntRes ϢդƤ
 *          ꥽ GroupRes ϢդƤ
 *  6
 *    IDTask6
 *    ͥ١14
 *    ¿ŵư1
 *    塼롧եץꥨץƥ
 *    ưưʤ
 *    סưåϤ٥(T6Evt)Ԥ
 *  7
 *    IDTask7
 *    ͥ١14
 *    ¿ŵư1
 *    塼롧եץꥨץƥ
 *    ưưʤ
 *    סưåϤ٥(T7Evt)Ԥ
 *  8
 *    IDTask8
 *    ͥ١14
 *    ¿ŵư1
 *    塼롧եץꥨץƥ
 *    ưưʤ
 *    סưåϤ٥(T8Evt)Ԥ
 *
 *  ߥӥ롼
 *  ꥢIO
 *    ISRIDRxHwSerialInt
 *    ͥ١2
 *    ƥꡧ2
 *    סޥɤ
 *  ꥽
 *  ٥꥽
 *    ꥽IDTskLevelRes
 *    ץѥƥɸ
 *  ѥ󥿥꥽
 *    ꥽IDCntRes
 *    ץѥƥɸ
 *  롼ץ꥽
 *    ꥽IDGroupRes
 *    ץѥƥ
 *  ٥
 *  ᥤ󥿥٥
 *    ٥IDMainEvt
 *  2٥
 *    ٥IDT2Evt
 *  3٥
 *    ٥IDT3Evt
 *  
 *  ƥॿޥ
 *    IDMAIN_HW_COUNTER
 *    ͡0999
 *    û͡1
 *  ץ륫
 *    IDSampleCnt
 *    ͡099
 *    û͡10
 *  顼
 *  ᥤ顼
 *    顼IDMainCycArm
 *    ١IDMAIN_HW_COUNTER
 *    󡧥٥ MainEvt
 *    ưưʤ
 *  ư顼
 *    顼IDActTskArm
 *    ١IDMAIN_HW_COUNTER
 *    󡧥ư Task1
 *    ưưʤ
 *  ٥ꥢ顼
 *    顼IDSetEvtArm
 *    ١IDMAIN_HW_COUNTER
 *    󡧥٥ T3Evt
 *    ưưʤ
 *  Хå¹ԥ顼
 *    顼IDCallBackArm
 *    ١IDMAIN_HW_COUNTER
 *    󡧥Хåؿ¹
 *    ưưʤ
 *  IncrementCounterǧѥ顼
 *    顼IDSampleArm
 *    ١IDSampleCnt
 *    󡧥Хåؿ¹
 *    ưưʤ
 *  ץꥱ⡼
 *  ưưʤ⡼
 *    ץꥱ⡼IDAppMode1
 *  Task1ưư⡼
 *    ץꥱ⡼IDAppMode2
 *  Task3ưư⡼
 *    ץꥱ⡼IDAppMode3
 *
 */

#include "Os.h"
#include "t_syslog.h"
#include "t_stdlib.h"
#include "sysmod/serial.h"
#include "sysmod/syslog.h"
#include "sample1.h"

#include "sysmod/banner.h"
#include "target_sysmod.h"
#include "target_serial.h"
#include "target_hw_counter.h"


#define GetHwCnt(x, y)
#define GetAppModeInfo()	(0)

/*
 *  եֹ̾λѤѿ
 */
extern const char8	*fatal_file_name;   /* ե̾ */
extern sint32		fatal_line_num;     /* ֹ */

/*
 *  ؿץȥ
 */
sint32 main(void);
TASK(MainTask);
TASK(HighPriorityTask);
TASK(NonPriTask);
TASK(Task1);
TASK(Task2);
TASK(Task3);
TASK(Task4);
TASK(Task5);
TASK(Task6);
TASK(Task7);
TASK(Task8);
ALARMCALLBACK(SysTimerAlmCb);
static void TaskProk(uint8 task_no);
static uint8 GetCommand(void);
static void PutActTsk(uint8 task_no);
static void PutActNonPriTsk(void);
static void PutTermTsk(uint8 task_no);
static void PutChainTsk(uint8 from_task_no, uint8 to_task_no);
static void PutSchedule(void);
static void PutTaskID(void);
static void PutTaskState(uint8 task_no);
static void PutDisAllInt(void);
static void PutSusAllInt(void);
static void PutSusOSInt(void);
static void PutHwCnt3(void);
static void PutGetCntRes(void);
static void PutGetTskRes(void);
static void PutRelTskRes(void);
static void PutSetEvt(uint8 task_no);
static void PutClrEvt(uint8 task_no);
static void PutGetEvt(uint8 task_no);
static void PutWaitEvt(uint8 task_no);
static void PutArmBase(void);
static void PutArmTick(void);
static void PutSetRel(uint8 alarm_no, uint8 tick_no, uint8 cycle_no);
static void PutSetAbs(uint8 alarm_no, uint8 tick_no, uint8 cycle_no);
static void PutCanArm(void);
static void PutAppMode(void);
static void schedule_table_sample_routine(void);

/*
 *  ǡХåե
 */
static volatile uint8		command_tbl[8];         /* ޥɰϤơ֥ */

/*
 *  ǡơ֥
 */
/* ̵٥ȥޥ */
#define invalid_mask	(EventMaskType) (0)

/* ٥ȥޥơ֥ */
static const EventMaskType	event_mask_tbl[] = {
	invalid_mask,
	T2Evt,
	T3Evt,
	invalid_mask,
	invalid_mask
};

/* IDơ֥ */
static const TaskType		task_id_tbl[] = {
	Task1,
	Task2,
	Task3,
	Task4,
	Task5
};

/* 顼IDơ֥ */
static const AlarmType		alarm_id_tbl[] = {
	ActTskArm,
	SetEvtArm,
	CallBackArm
};

/* ƥåͥơ֥ */
static const TickType		tick_tbl[] = {
	(TickType) 500,
	(TickType) 900
};

/* ͥơ֥ */
static const TickType		cycle_tbl[] = {
	(TickType) 0,
	(TickType) COUNTER_MIN_CYCLE
};

/* ٥ȥޥ̾ʸơ֥ */
static const char8			*event_name_tbl[] = {
	"Invalid",
	"T2Evt",
	"T3Evt",
	"Invalid",
	"Invalid"
};

/* ̾ʸơ֥ */
static const char8			*task_name_tbl[] = {
	"Task1",
	"Task2",
	"Task3",
	"Task4",
	"Task5"
};

/* ʸơ֥ */
static const char8			*task_state_tbl[] = {
	"SUSPENDED",
	"RUNNING",
	"READY",
	"WAITING",
};

/* 顼̾ʸơ֥ */
static const char8			*alarm_name_tbl[] = {
	"ActTskArm",
	"SetEvtArm",
	"CallBackArm"
};

/*
 *  API顼ޥ
 *
 *  ErrorHookͭξErrorHook
 *  顼Ϥ, ErrorHook̵ξ
 *  ʲΥޥꥨ顼ϤԤ
 */
#if defined(CFG_USE_ERRORHOOK)
#define error_log(api)	(api)
#else /* !defined( CFG_USE_ERRORHOOK ) */
#define	error_log(api)										   \
	{														   \
		StatusType ercd;									   \
		ercd = api;     /* API¹ */						   \
		if (ercd != E_OK) {									   \
			syslog(LOG_INFO, "Error:%d", atk2_strerror(ercd)); \
		}													   \
	}
#endif /* defined( CFG_USE_ERRORHOOK ) */

/*
 *  桼ᥤؿ
 *
 *  ץꥱ⡼ɤȽǤȡͥ뵯ư
 */
sint32
main(void)
{
	AppModeType	crt_app_mode;

	/*
	 *  ץꥱ⡼ɤȽ
	 */
	switch (GetAppModeInfo()) {
	case 0:
		crt_app_mode = AppMode1;
		break;
	case 1:
		crt_app_mode = AppMode2;
		break;
	default:
		crt_app_mode = AppMode3;
		break;
	}

	/*
	 *  ͥ뵯ư
	 */
	StartOS(crt_app_mode);

	while (1) {
	}
}   /* main */

/*
 *  ᥤ󥿥
 *
 *  桼ޥɤμȡޥɤȤν¹
 */
TASK(MainTask)
{
	uint8		command;
	uint8		task_no;
	uint32		i;

	TickType	val = 0U;
	TickType	eval = 0U;

	/*
	 *  ֹ桦ޥɥХåե
	 */
	task_no = (uint8) (0);
	for (i = 0U; i < (sizeof(command_tbl) / sizeof(command_tbl[0])); i++) {
		command_tbl[i] = 0U;
	}

	/*
	 *  MainCycArm顼Ȥ
	 */
	SetRelAlarm(MainCycArm, TICK_FOR_10MS, TICK_FOR_10MS);

	/*
	 *  ޥɼ¹ԥ롼
	 */
	while (1) {
		WaitEvent(MainEvt);     /* 10msκȻԤ */
		ClearEvent(MainEvt);

		/*
		 *  ϥޥɼ
		 */
		syslog(LOG_INFO, "Input Command:");
		command = GetCommand();

		/*
		 *  ϥޥɥå
		 */
		if ((command <= (uint8) (0x1fU)) || (command >= (uint8) (0x80U))) {
			syslog(LOG_INFO, "Not ASCII character");
		}
		else {
#ifndef OMIT_ECHO
			syslog(LOG_INFO, "%c", command);
#endif /* OMIT_ECHO */

			/*
			 *  ޥȽ
			 */
			switch (command) {
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
				/*
				 *  оݥѹ
				 */
				task_no = (uint8) (command - '1');
				break;
			case 'A':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case 'z':
			case 'k':
			case 'K':
			case 'l':
			case 'i':
			case 'w':
			case 'W':
				/*
				 *  ؤΥޥ
				 */
				command_tbl[task_no] = command;
				break;
			/*
			 *  ʹߤϥᥤ󥿥ǥޥɽ
			 */
			case 'a':
				PutActTsk(task_no);
				break;
			case 's':
				PutSchedule();
				break;
			case 'S':
				PutActNonPriTsk();
				break;
			case 'Z':
				PutTaskState(task_no);
				break;
			case 'x':
				syslog(LOG_INFO, "call RAISE_CPU_EXCEPTION");
				RAISE_CPU_EXCEPTION;
				break;
			case 'd':
				PutDisAllInt();
				break;
			case 'D':
				PutSusAllInt();
				break;
			case 'f':
				PutSusOSInt();
				break;
			case 'T':
				PutHwCnt3();
				break;
			case 'e':
				PutSetEvt(task_no);
				break;
			case 'E':
				PutGetEvt(task_no);
				break;
			case 'b':
				PutArmBase();
				break;
			case 'B':
				PutArmTick();
				PutArmTick();
				break;
			case 'v':
				/* SetRelAlarm(ActTskArm, 500, 0)¹ */
				PutSetRel(0U, 0U, 0U);
				break;
			case 'V':
				/* SetRelAlarm(SetEvtArm, 500, 0)¹ */
				PutSetRel(1U, 0U, 0U);
				break;
			case 'n':
				/* SetRelAlarm(CallBackArm, 900, 0)¹ */
				PutSetRel(2U, 1U, 0U);
				break;
			case 'N':
				/* SetRelAlarm(CallBackArm, 900, 500)¹ */
				PutSetRel(2U, 1U, 1U);
				break;
			case 'm':
				/* SetAbsAlarm(CallBackArm, 900, 0)¹ */
				PutSetAbs(2U, 1U, 0U);
				break;
			case 'M':
				/* SetAbsAlarm(CallBackArm, 900, 500)¹ */
				PutSetAbs(2U, 1U, 1U);
				break;
			case 'h':
				/* CancelAlarm(CallBackArm)¹ */
				PutCanArm();
				break;
			case 'c':
				syslog(LOG_INFO, "Call IncrementCounter(SampleCnt)");
				IncrementCounter(SampleCnt);
				break;
			case 'C':
				syslog(LOG_INFO, "Call IncrementCounter(SampleCnt2)");
				IncrementCounter(SampleCnt2);
				break;
			case 'j':
				syslog(LOG_INFO, "GetCounterValue(MAIN_HW_COUNTER, val)");
				GetCounterValue(MAIN_HW_COUNTER, &val);
				syslog(LOG_INFO, " val = %d", val);
				break;
			case 'J':
				syslog(LOG_INFO, "Pre val = %d", val);
				syslog(LOG_INFO, "GetElapsedValue(MAIN_HW_COUNTER, val ,eval)");
				GetElapsedValue(MAIN_HW_COUNTER, &val, &eval);
				syslog(LOG_INFO, " val = %d", val);
				syslog(LOG_INFO, " eval = %d", eval);
				break;
			case 'r':
				syslog(LOG_INFO, "GetISRID() Call from Task Context");
				syslog(LOG_INFO, "GetISRID() = %d", GetISRID());
				break;
			case 'p':
				PutAppMode();
				break;
			case 't':
				schedule_table_sample_routine();
				break;
			case 'q':
				ShutdownOS(E_OK);
				break;
			case 'Q':
				ShutdownOS(E_OS_STATE);
				break;
			default:
				/* 嵭Υޥɰʳξ硤Ԥʤ */
				break;
			}
		}
	}

	/*
	 *  ˤϤʤ
	 */
	syslog(LOG_INFO, "MainTask TERMINATE");
	error_log(TerminateTask());
}   /* TASK( MainTask ) */

/*
 *  ǹͥ٥
 *
 *  ƥΥץꥨץȳǧ
 */
TASK(HighPriorityTask)
{
	syslog(LOG_INFO, "HighPriorityTask ACTIVATE");
	error_log(TerminateTask());
}   /* TASK( HighPriorityTask ) */


/*
 *  Υץꥨץƥ֥
 *
 *  ¹ϥץꥨץȤʤȤγǧ
 */
TASK(NonPriTask)
{
	syslog(LOG_INFO, "NonPriTask ACTIVATE");
	syslog(LOG_INFO, "Call ActivateTask(HighPriorityTask)");
	error_log(ActivateTask(HighPriorityTask));
	syslog(LOG_INFO, "NonPriTask TERMINATE");

	error_log(TerminateTask());
}   /* TASK( NonPriTask ) */


/*
 *  ¹ԥ1
 */
TASK(Task1)
{
	TaskProk(0U);
}   /* TASK( Task1 ) */


/*
 *  ¹ԥ2
 */
TASK(Task2)
{
	TaskProk(1U);
}   /* TASK( Task2 ) */


/*
 *  ¹ԥ3
 */
TASK(Task3)
{
	TaskProk(2U);
}   /* TASK( Task3 ) */


/*
 *  ¹ԥ4
 */
TASK(Task4)
{
	TaskProk(3U);
}   /* TASK( Task4 ) */


/*
 *  ¹ԥ5
 */
TASK(Task5)
{
	TaskProk(4U);
}   /* TASK( Task5 ) */


/*
 *  ¹ԥ
 *
 *  ᥤ󥿥Τ줿ޥɤȤν¹
 */
static void
TaskProk(uint8 task_no)
{
	uint8 command;          /* ޥХåե */

	/*
	 *  ư
	 */
	syslog(LOG_INFO, "%s ACTIVATE", task_name_tbl[task_no]);

	/*
	 *  ޥɼ¹ԥ롼
	 */
	while (1) {

		/*
		 *  ޥɼ
		 */
		while (command_tbl[task_no] == '\0') {
		}
		command = command_tbl[task_no];
		command_tbl[task_no] = 0U;

		/*
		 *  ޥȽ
		 */
		switch (command) {
		case 'A':
			PutTermTsk(task_no);
			break;
		case '!':
		case '"':
		case '#':
		case '$':
		case '%':
			PutChainTsk(task_no, (command - '!'));
			break;
		case 'z':
			PutTaskID();
			break;
		case 'k':
			PutGetTskRes();
			break;
		case 'K':
			PutRelTskRes();
			break;
		case 'i':
			PutGetCntRes();
			break;
		case 'w':
			PutClrEvt(task_no);
			break;
		case 'W':
			PutWaitEvt(task_no);
			break;
		default:
			/* 嵭Υޥɰʳξ硤ϹԤʤ */
			break;
		}
	}
}   /* TaskProk */

/*
 *  ޥɼ
 */
static uint8
GetCommand(void)
{
	uint8 command;          /* ޥɼХåե */

	/*
	 *  ޥɤޤǥ롼
	 */
	command = '\0';
	do {
		WaitEvent(MainEvt);     /* 10ms */
		ClearEvent(MainEvt);
		RecvPolSerialChar(&command);    /* Хåեݡ */
		if (command == '\n') {
			command = '\0';
		}
	} while (command == '\0');


	return(command);
}   /* GetCommand */

/*
 *  ActivateTask ¹ԡϽ
 */
static void
PutActTsk(uint8 task_no)
{
	syslog(LOG_INFO, "Call ActivateTask(%s)", task_name_tbl[task_no]);

	error_log(ActivateTask(task_id_tbl[task_no]));

}   /* PutActTsk	*/

/*
 *  ActivateTask ¹(NonPriTask)Ͻ
 */
static void
PutActNonPriTsk(void)
{
	syslog(LOG_INFO, "Call ActivateTask(NonPriTask)");

	error_log(ActivateTask(NonPriTask));
}   /* PutActNonPriTsk */

/*
 *  TerminateTask ¹ԡϽ
 */
static void
PutTermTsk(uint8 task_no)
{
	StatusType ercd;        /* 顼 */

	syslog(LOG_INFO, "%s TERMINATE", task_name_tbl[task_no]);

	ercd = TerminateTask();
	ShutdownOS(ercd);
}

/*
 *  ChainTask ¹ԡϽ
 */
static void
PutChainTsk(uint8 from_task_no, uint8 to_task_no)
{
	StatusType ercd;            /* 顼 */

	syslog(LOG_INFO, "Call ChainTask(%s)", task_name_tbl[to_task_no]);
	syslog(LOG_INFO, "%s TERMINATE", task_name_tbl[from_task_no]);

	ercd = ChainTask(task_id_tbl[to_task_no]);
	if (ercd == E_OS_LIMIT) {
		syslog(LOG_INFO, "Call TerminateTask()");
		syslog(LOG_INFO, "Because of ChainTask E_OS_LIMIT return");
		ercd = TerminateTask();
	}
	ShutdownOS(ercd);
}   /* PutChainTsk */

/*
 *  Schedule ¹ԡϽ
 */
static void
PutSchedule(void)
{
	syslog(LOG_INFO, "Call ActivateTask(HighPriorityTask)");

	error_log(ActivateTask(HighPriorityTask));
	syslog(LOG_INFO, "Call Schedule()");

	error_log(Schedule());
	syslog(LOG_INFO, "Retrun Schedule()");
}   /* PutSchedule	*/

/*
 *  GetTaskID ¹ԡϽ
 */
static void
PutTaskID(void)
{
	TaskType task_id;           /* IDХåե */

	error_log(GetTaskID(&task_id));

	syslog(LOG_INFO, "TaskID:%d", task_id);
}   /* PutTaskID	*/

/*
 *  GetTaskState ¹ԡϽ
 */
static void
PutTaskState(uint8 task_no)
{
	TaskStateType state;        /* IDХåե */

	error_log(GetTaskState(task_id_tbl[task_no], &state));

	syslog(LOG_INFO, task_name_tbl[task_no]);
	syslog(LOG_INFO, " State:%s", task_state_tbl[state]);
}   /* PutTaskState	*/

/*
 *  DisableAllInterrupts/EnableAllInterrupts ¹ԡϽ
 */
static void
PutDisAllInt(void)
{
	syslog(LOG_INFO, "Call DisableAllInterrupts");

	DisableAllInterrupts();

	PutHwCnt3();
	syslog(LOG_INFO, "Call EnableAllInterrupts");

	EnableAllInterrupts();
}   /* PutDisAllInt	*/

/*
 *  SuspendAllInterrupts/ResumeAllInterrupts ¹ԡϽ
 */
static void
PutSusAllInt(void)
{
	syslog(LOG_INFO, "Call SuspendAllInterrupts");

	SuspendAllInterrupts();

	PutHwCnt3();
	syslog(LOG_INFO, "Call SuspendAllInterrupts");

	SuspendAllInterrupts();

	PutHwCnt3();
	syslog(LOG_INFO, "Call ResumeAllInterrupts");

	ResumeAllInterrupts();

	PutHwCnt3();
	syslog(LOG_INFO, "Call ResumeAllInterrupts");

	ResumeAllInterrupts();
}   /* PutSusAllInt	*/

/*
 *  SuspendOSInterrupts/ResumeOSInterrupts ¹ԡϽ
 */
static void
PutSusOSInt(void)
{
	syslog(LOG_INFO, "Call SuspendOSInterrupts");

	SuspendOSInterrupts();

	PutHwCnt3();
	syslog(LOG_INFO, "Call SuspendOSInterrupts");

	SuspendOSInterrupts();

	PutHwCnt3();
	syslog(LOG_INFO, "Call SuspendAllInterrupts");

	SuspendAllInterrupts();

	PutHwCnt3();
	syslog(LOG_INFO, "Call ResumeAllInterrupts");

	ResumeAllInterrupts();

	PutHwCnt3();
	syslog(LOG_INFO, "Call ResumeOSInterrupts");

	ResumeOSInterrupts();

	PutHwCnt3();
	syslog(LOG_INFO, "Call ResumeOSInterrupts");

	ResumeOSInterrupts();
}   /* PutSusOSInt */

/*
 *  ưƥHWͤΥϽ
 */
static void
PutHwCnt3(void)
{
	uint8	isr1_cnt = 0U;      /* C1ISR ͼХåե */
	uint8	isr2_cnt = 0U;      /* C2ISR ͼХåե */
	uint8	cnt;                /* ϲ */

	for (cnt = 0U; cnt < 3U; cnt++) {
		GetHwCnt(&isr1_cnt, &isr2_cnt);
		syslog(LOG_INFO, "C1ISR Cnt:%d, C2ISR Cnt:%d",
			   isr1_cnt, isr2_cnt);
	}
}   /* PutHwCnt3 */

/*
 *  GetResource/ReleaseResource ¹(󥿥꥽)Ͻ
 */
static void
PutGetCntRes(void)
{
	syslog(LOG_INFO, "Call GetResource(CntRes)");
	error_log(GetResource(CntRes));

	PutHwCnt3();
	syslog(LOG_INFO, "Call ReleaseResource(CntRes)");

	error_log(ReleaseResource(CntRes));
}   /* PutGetCntRes	*/

/*
 *  GetResource ¹(٥)Ͻ
 */
static void
PutGetTskRes(void)
{
	syslog(LOG_INFO, "Call GetResource(TskLevelRes)");

	error_log(GetResource(TskLevelRes));
}   /* PutGetTskRes */

/*
 *  ReleaseResource ¹(٥)Ͻ
 */
static void
PutRelTskRes(void)
{
	syslog(LOG_INFO, "Call ReleaseResource(TskLevelRes)");

	error_log(ReleaseResource(TskLevelRes));
}

/*
 *  SetEvent ¹ԡϽ
 */
static void
PutSetEvt(uint8 task_no)
{
	syslog(LOG_INFO, "Call SetEvent(%s, %s)",
		   task_name_tbl[task_no], event_name_tbl[task_no]);

	error_log(SetEvent(task_id_tbl[task_no], event_mask_tbl[task_no]));
}   /* PutSetEvt */

/*
 *  ClearEvent ¹ԡϽ
 */
static void
PutClrEvt(uint8 task_no)
{
	syslog(LOG_INFO, "Call ClearEvent(%s)", event_name_tbl[task_no]);

	error_log(ClearEvent(event_mask_tbl[task_no]));
}   /* PutClrEvt */

/*
 *  GetEvent ¹ԡϽ
 */
static void
PutGetEvt(uint8 task_no)
{
	EventMaskType mask;             /* ٥ȥޥХåե */

	error_log(GetEvent(task_id_tbl[task_no], &mask));

	syslog(LOG_INFO, "%s Event Mask:0x%x", task_name_tbl[task_no], mask);
}   /* PutGetEvt */

/*
 *  WaitEvent ¹ԡϽ
 */
static void
PutWaitEvt(uint8 task_no)
{
	syslog(LOG_INFO, "Call WaitEvent(%s)", event_name_tbl[task_no]);

	error_log(WaitEvent(event_mask_tbl[task_no]));
	syslog(LOG_INFO, "Return WaitEvent(%s)", event_name_tbl[task_no]);
}   /* PutWaitEvt */

/*
 *  GetAlarmBase ¹ԡϽ
 */
static void
PutArmBase(void)
{
	AlarmBaseType info;             /* 顼١Хåե */

	error_log(GetAlarmBase(MainCycArm, &info));

	syslog(LOG_INFO, "MainCycArm Base:");
	syslog(LOG_INFO, "\tMAXALLOWEDVALUE=%d", info.maxallowedvalue);
	syslog(LOG_INFO, "\tTICKSPERBASE=%d", info.ticksperbase);
	syslog(LOG_INFO, "\tMINCYCLE=%d", info.mincycle);
}   /* PutArmBase */

/*
 *  PutArmTick ¹ԡϽ
 */
static void
PutArmTick(void)
{
	TickType tick;              /* ĤƥåХåե */

	error_log(GetAlarm(MainCycArm, &tick));

	syslog(LOG_INFO, "MainCycArm Tick:%d", tick);
}   /* PutArmTick */

/*
 *  SetRelAlarm ¹ԡϽ
 */
static void
PutSetRel(uint8 alarm_no, uint8 tick_no, uint8 cycle_no)
{
	syslog(LOG_INFO, "Call SetRelAlarm(%s, %d, %d)",
		   alarm_name_tbl[alarm_no], tick_tbl[tick_no], cycle_tbl[cycle_no]);

	error_log(SetRelAlarm(alarm_id_tbl[alarm_no],
						  tick_tbl[tick_no], cycle_tbl[cycle_no]));
}   /* PutSetRel	*/

/*
 *  SetAbsAlarm ¹ԡϽ
 */
static void
PutSetAbs(uint8 alarm_no, uint8 tick_no, uint8 cycle_no)
{
	syslog(LOG_INFO, "Call SetAbsAlarm(%s, %d, %d)",
		   alarm_name_tbl[alarm_no], tick_tbl[tick_no], cycle_tbl[cycle_no]);

	error_log(SetAbsAlarm(alarm_id_tbl[alarm_no],
						  tick_tbl[tick_no], cycle_tbl[cycle_no]));
}   /* PutSetAbs */

/*
 *  CancelAlarm ¹ԡϽ
 */
static void
PutCanArm(void)
{
	syslog(LOG_INFO, "Call CancelAlarm(CallBackArm)");

	error_log(CancelAlarm(CallBackArm));
}   /* PutCanArm */

/*
 *  GetActiveApplicationMode ¹ԡϽ
 */
static void
PutAppMode(void)
{
	switch (GetActiveApplicationMode()) {
	case AppMode1:
		syslog(LOG_INFO, "ActiveApplicationMode:AppMode1");
		break;
	case AppMode2:
		syslog(LOG_INFO, "ActiveApplicationMode:AppMode2");
		break;
	case AppMode3:
		syslog(LOG_INFO, "ActiveApplicationMode:AppMode3");
		break;
	default:
		syslog(LOG_INFO, "ActiveApplicationMode:Non");
		break;
	}
}   /* PutAppMode */


/*
 *  顼եå롼
 */
#ifdef CFG_USE_ERRORHOOK
void
ErrorHook(StatusType Error)
{
	/*
	 *  顼װȤΥѥ᡼
	 */
	switch (OSErrorGetServiceId()) {
	case OSServiceId_ActivateTask:
		syslog(LOG_INFO, "Error:%s=ActivateTask(%d)", atk2_strerror(Error), OSError_ActivateTask_TaskID());
		break;
	case OSServiceId_TerminateTask:
		syslog(LOG_INFO, "Error:%s=TerminateTask()", atk2_strerror(Error));
		break;
	case OSServiceId_ChainTask:
		syslog(LOG_INFO, "Error:%s=ChainTask(%d)", atk2_strerror(Error), OSError_ChainTask_TaskID());
		break;
	case OSServiceId_Schedule:
		syslog(LOG_INFO, "Error:%s=Schedule()", atk2_strerror(Error));
		break;
	case OSServiceId_GetTaskID:
		syslog(LOG_INFO, "Error:%s=GetTaskID(0x%p)", atk2_strerror(Error), OSError_GetTaskID_TaskID());
		break;
	case OSServiceId_GetTaskState:
		syslog(LOG_INFO, "Error:%s=GetTaskState(%d, 0x%p)", atk2_strerror(Error),
			   OSError_GetTaskState_TaskID(), OSError_GetTaskState_State());
		break;
	case OSServiceId_EnableAllInterrupts:
		syslog(LOG_INFO, "Error:%s=EnableAllInterrupts()", atk2_strerror(Error));
		break;
	case OSServiceId_DisableAllInterrupts:
		syslog(LOG_INFO, "Error:%s=DisableAllInterrupts()", atk2_strerror(Error));
		break;
	case OSServiceId_ResumeAllInterrupts:
		syslog(LOG_INFO, "Error:%s=ResumeAllInterrupts()", atk2_strerror(Error));
		break;
	case OSServiceId_SuspendAllInterrupts:
		syslog(LOG_INFO, "Error:%s=SuspendAllInterrupts()", atk2_strerror(Error));
		break;
	case OSServiceId_ResumeOSInterrupts:
		syslog(LOG_INFO, "Error:%s=ResumeOSInterrupts()", atk2_strerror(Error));
		break;
	case OSServiceId_SuspendOSInterrupts:
		syslog(LOG_INFO, "Error:%s=SuspendOSInterrupts()", atk2_strerror(Error));
		break;
	case OSServiceId_GetISRID:
		syslog(LOG_INFO, "Error:%s=GetISRID()", atk2_strerror(Error));
		break;
	case OSServiceId_GetResource:
		syslog(LOG_INFO, "Error:%s=GetResource(%d)", atk2_strerror(Error), OSError_GetResource_ResID());
		break;
	case OSServiceId_ReleaseResource:
		syslog(LOG_INFO, "Error:%s=ReleaseResource(%d)", atk2_strerror(Error), OSError_ReleaseResource_ResID());
		break;
	case OSServiceId_SetEvent:
		syslog(LOG_INFO, "Error:%s=SetEvent(%d, 0x%x)", atk2_strerror(Error),
			   OSError_SetEvent_TaskID(), OSError_SetEvent_Mask());
		break;
	case OSServiceId_ClearEvent:
		syslog(LOG_INFO, "Error:%s=ClearEvent(0x%x)", atk2_strerror(Error), OSError_ClearEvent_Mask());
		break;
	case OSServiceId_GetEvent:
		syslog(LOG_INFO, "Error:%s=GetEvent(%d, 0x%p)", atk2_strerror(Error),
			   OSError_GetEvent_TaskID(), OSError_GetEvent_Event());
		break;
	case OSServiceId_WaitEvent:
		syslog(LOG_INFO, "Error:%s=WaitEvent(0x%x)", atk2_strerror(Error), OSError_WaitEvent_Mask());
		break;
	case OSServiceId_GetAlarmBase:
		syslog(LOG_INFO, "Error:%s=GetAlarmBase(0x%p)", atk2_strerror(Error), OSError_GetAlarmBase_AlarmID());
		break;
	case OSServiceId_GetAlarm:
		syslog(LOG_INFO, "Error:%s=GetAlarm(%d, 0x%p)", atk2_strerror(Error),
			   OSError_GetAlarm_AlarmID(), OSError_GetAlarm_Tick());
		break;
	case OSServiceId_SetRelAlarm:
		syslog(LOG_INFO, "Error:%s=SetRelAlarm(%d, %d, %d)", atk2_strerror(Error),
			   OSError_SetRelAlarm_AlarmID(), OSError_SetRelAlarm_increment(), OSError_SetRelAlarm_cycle());
		break;
	case OSServiceId_SetAbsAlarm:
		syslog(LOG_INFO, "Error:%s=SetAbsAlarm(%d, %d, %d)", atk2_strerror(Error),
			   OSError_SetAbsAlarm_AlarmID(), OSError_SetAbsAlarm_start(), OSError_SetAbsAlarm_cycle());
		break;
	case OSServiceId_CancelAlarm:
		syslog(LOG_INFO, "Error:%s=CancelAlarm(%d)", atk2_strerror(Error), OSError_CancelAlarm_AlarmID());
		break;
	case OSServiceId_StartScheduleTableRel:
		syslog(LOG_INFO, "Error:%s=StartScheduleTableRel(%d, %d)", atk2_strerror(Error),
			   OSError_StartScheduleTableRel_ScheduleTableID(), OSError_StartScheduleTableRel_Offset());
		break;
	case OSServiceId_StartScheduleTableAbs:
		syslog(LOG_INFO, "Error:%s=StartScheduleTableAbs(%d, %d)", atk2_strerror(Error),
			   OSError_StartScheduleTableAbs_ScheduleTableID(), OSError_StartScheduleTableAbs_Start());
		break;
	case OSServiceId_StopScheduleTable:
		syslog(LOG_INFO, "Error:%s=StopScheduleTable(%d)", atk2_strerror(Error), OSError_StopScheduleTable_ScheduleTableID());
		break;
	case OSServiceId_NextScheduleTable:
		syslog(LOG_INFO, "Error:%s=NextScheduleTable(%d, %d)", atk2_strerror(Error),
			   OSError_NextScheduleTable_ScheduleTableID_From(), OSError_NextScheduleTable_ScheduleTableID_To());
		break;
	case OSServiceId_GetScheduleTableStatus:
		syslog(LOG_INFO, "Error:%s=GetScheduleTableStatus(%d, 0x%p)", atk2_strerror(Error),
			   OSError_GetScheduleTableStatus_ScheduleTableID(), OSError_GetScheduleTableStatus_ScheduleStatus());
		break;
	case OSServiceId_GetActiveApplicationMode:
		syslog(LOG_INFO, "Error:%s=GetActiveApplicationMode()", atk2_strerror(Error));
		break;
	case OSServiceId_StartOS:
		syslog(LOG_INFO, "Error:%s=StartOS()", atk2_strerror(Error));
		break;
	case OSServiceId_ShutdownOS:
		syslog(LOG_INFO, "Error:%s=ShutdownOS()", atk2_strerror(Error));
		break;
	case OSServiceId_IncrementCounter:
		syslog(LOG_INFO, "Error:%s=IncrementCounter(%d)", atk2_strerror(Error), OSError_IncrementCounter_CounterID());
		break;
	case OSServiceId_TaskMissingEnd:
		syslog(LOG_INFO, "Error:%s=MissingEnd()", atk2_strerror(Error));
		break;
	default:
		syslog(LOG_INFO, "Error:%s=UnKnownFunc()", atk2_strerror(Error));
		break;
	}

}   /* ErrorHook */
#endif /* CFG_USE_ERRORHOOK */

/*
 *  ץ쥿եå롼
 *
 *  롼ƽФ
 */
#ifdef CFG_USE_PRETASKHOOK
void
PreTaskHook(void)
{
}   /* PreTaskHook */
#endif /* CFG_USE_PRETASKHOOK */

/*
 *  ݥȥեå롼
 *
 *  롼ƽФ
 */
#ifdef CFG_USE_POSTTASKHOOK
void
PostTaskHook(void)
{
}   /* PostTaskHook */
#endif /* CFG_USE_POSTTASKHOOK */

/*
 *  ȥåץեå롼
 */
#ifdef CFG_USE_STARTUPHOOK
#ifdef TOPPERS_ENABLE_SYS_TIMER
extern void target_timer_initialize(void);
#endif /* TOPPERS_ENABLE_SYS_TIMER */

void
StartupHook(void)
{
#ifdef TOPPERS_ENABLE_SYS_TIMER
	target_timer_initialize();
#endif /* TOPPERS_ENABLE_SYS_TIMER */
	syslog_initialize();
	syslog_msk_log(LOG_UPTO(LOG_INFO));
	InitSerial();
	print_banner();
}   /* StartupHook */
#endif /* CFG_USE_STARTUPHOOK */

/*
 *  åȥեå롼
 */
#ifdef CFG_USE_SHUTDOWNHOOK
#ifdef TOPPERS_ENABLE_SYS_TIMER
extern void target_timer_terminate(void);
#endif /* TOPPERS_ENABLE_SYS_TIMER */

void
ShutdownHook(StatusType Error)
{
	/* λ */
	syslog(LOG_INFO, "");
	syslog(LOG_INFO, "Sample System ShutDown");
	syslog(LOG_INFO, "ShutDownCode:%s", atk2_strerror(Error));
	syslog(LOG_INFO, "");

	if (Error == E_OS_SYS_ASSERT_FATAL) {
		syslog(LOG_INFO, "fatal_file_name:%s", fatal_file_name);
		syslog(LOG_INFO, "fatal_line_num:%d", fatal_line_num);
	}

#ifdef TOPPERS_ENABLE_SYS_TIMER
	target_timer_terminate();
#endif /* TOPPERS_ENABLE_SYS_TIMER */
	TermSerial();

}   /* ShutdownHook */
#endif /* CFG_USE_SHUTDOWNHOOK */

/*
 *  ץƥեå롼
 */
#ifdef CFG_USE_PROTECTIONHOOK
ProtectionReturnType
ProtectionHook(StatusType FatalError)
{
	StatusType ercd;

	syslog(LOG_INFO, "");
	syslog(LOG_INFO, "ProtectionHook");

	if (FatalError == E_OS_STACKFAULT) {
		syslog(LOG_INFO, "E_OS_STACKFAULT");
		ercd = PRO_SHUTDOWN;
	}
	else if (FatalError == E_OS_PROTECTION_EXCEPTION) {
		syslog(LOG_INFO, "E_OS_PROTECTION_EXCEPTION");
		ercd = PRO_IGNORE;
	}
	else {
		ercd = PRO_SHUTDOWN;
	}

	return(ercd);
}
#endif /* CFG_USE_PROTECTIONHOOK */

/*
 *  ƥॿޤˤ륢顼ॳХå
 */
ALARMCALLBACK(SysTimerAlmCb)
{
	/*
	 *  Хå¹ԥ
	 */
	syslog(LOG_INFO, "CallBackArm Expire");

}   /* ALARMCALLBACK(SysTimerAlmCb) */

/*
 *  IncrementCounterǧѥ顼ॳХå
 */
ALARMCALLBACK(SampleAlmCb)
{
	/*
	 *  Хå¹ԥ
	 */
	syslog(LOG_INFO, "SampleArm Expire");

}   /* ALARMCALLBACK( SampleAlmCb ) */

/*
 *  IncrementCounterǧѥ顼ॳХå
 */
ALARMCALLBACK(SampleAlmCb2)
{
	/*
	 *  Хå¹ԥ
	 */
	syslog(LOG_INFO, "SampleArm2 Expire");

}   /* ALARMCALLBACK( SampleAlmCb2 ) */

/*
 *  塼ơ֥ƥѥᥤ롼
 *
 *  桼ޥɤμȡޥɤȤν¹
 */
static void
schedule_table_sample_routine(void)
{
	uint8					command;                /* ޥɥХåե */
	ScheduleTableType		scheduletable_id;       /* ޥɰХåե */
	ScheduleTableStatusType	status;                 /* 塼ְ */
	TickType				val;                    /* 󥿤θ */
	uint8					flag = FALSE;           /* ꥿󤹤뤫Ƚꤹ뤿Υե饰 */

	syslog(LOG_INFO, "\t[ schedule table sample routine IN, press 't' OUT ]");
	syslog(LOG_INFO, "");

	scheduletable_id = scheduletable1;
	/*
	 *  ޥɼ¹ԥ롼
	 */
	while (1) {

		WaitEvent(MainEvt);     /* 10msκȻԤ */
		ClearEvent(MainEvt);

		/*
		 *  ϥޥɼ
		 */
		syslog(LOG_INFO, "Input Command:");
		command = GetCommand();
		syslog(LOG_INFO, "%c", command);

		/*
		 *  ޥȽ
		 */
		switch (command) {
		case '1':
			scheduletable_id = scheduletable1;
			break;
		case '2':
			scheduletable_id = scheduletable2;
			break;
		case 'i':
			IncrementCounter(SchtblSampleCnt);
			val = 0U;
			GetCounterValue(SchtblSampleCnt, &val);
			if ((val % 5U) == 0U) {
				syslog(LOG_INFO, "\tGetCounterValue(SchtblSampleCnt ) = %d", val);
			}
			break;
		case 's':
			syslog(LOG_INFO, "\tStartScheduleTableRel(scheduletable%d, 5)", scheduletable_id + 1U);
			error_log(StartScheduleTableRel(scheduletable_id, 5U));
			break;
		case 'S':
			syslog(LOG_INFO, "\tStartScheduleTableAbs(scheduletable%d, 5)", scheduletable_id + 1U);
			error_log(StartScheduleTableAbs(scheduletable_id, 5U));
			break;
		case 'f':
			syslog(LOG_INFO, "\tStopScheduleTable(scheduletable%d)", scheduletable_id + 1U);
			error_log(StopScheduleTable(scheduletable_id));
			break;
		case 'n':
			syslog(LOG_INFO, "\tNextScheduleTable(scheduletable%d, scheduletable%d)", scheduletable_id + 1U, scheduletable2 + 1U);
			error_log(NextScheduleTable(scheduletable_id, scheduletable2));
			break;
		case 'N':
			syslog(LOG_INFO, "\tNextScheduleTable(scheduletable%d, scheduletable%d)", scheduletable_id + 1U, scheduletable1 + 1U);
			error_log(NextScheduleTable(scheduletable_id, scheduletable1));
			break;
		case 'g':
			status = 0U;
			syslog(LOG_INFO, "\tGetScheduleTableStatus(scheduletable%d, status)", scheduletable_id + 1U);
			error_log(GetScheduleTableStatus(scheduletable_id, &status));
			syslog(LOG_INFO, "\tstatus = %d", status);
			break;
		case 't':
			syslog(LOG_INFO, "\t[ schedule table sample routine OUT, press 't' IN ]");
			flag = TRUE;
			break;
		case 'q':
			ShutdownOS(E_OK);
			break;
		case 'Q':
			ShutdownOS(E_OS_STATE);
			break;
		default:
			/* ޥɤ嵭ΥʳʤϹԤʤ */
			break;
		}
		/*  ե饰ΩäƤ硤꥿󤹤  */
		if (flag == TRUE) {
			return;
		}
	}
}   /* schedule_table_sample_routine */

/*
 *  塼ơ֥ǧѥ6
 */
TASK(Task6)
{
	/*
	 *  ư
	 */
	syslog(LOG_INFO, "Task6 ACTIVATE");
	WaitEvent(T6Evt);
	syslog(LOG_INFO, "Task6 FINISH");
	TerminateTask();
}   /* TASK( Task6 ) */


/*
 *  塼ơ֥ǧѥ7
 */
TASK(Task7)
{
	/*
	 *  ư
	 */
	syslog(LOG_INFO, "Task7 ACTIVATE");
	WaitEvent(T7Evt);
	syslog(LOG_INFO, "Task7 FINISH");
	TerminateTask();
}   /* TASK( Task7 ) */


/*
 *  塼ơ֥ǧѥ8
 */
TASK(Task8)
{
	/*
	 *  ư
	 */
	syslog(LOG_INFO, "Task8 ACTIVATE");
	WaitEvent(T8Evt);
	syslog(LOG_INFO, "Task8 FINISH");
	TerminateTask();
}   /* TASK( Task8 ) */
